#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DarkGray
#property indicator_color2  DeepSkyBlue
#property indicator_color3  Red
#property indicator_style1  STYLE_DOT
#property indicator_width2  3
#property indicator_width3  3

extern int    FastEMA            = 12;
extern int    SlowEMA            = 26;
extern int    Price              = PRICE_CLOSE;
extern int    AtrPeriod          = 20;
extern double AtrMultiplier      = 2;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsNotification = false;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;

double stop[];
double stopdu[];
double stopdd[];
 
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,stop);
   SetIndexBuffer(1,stopdu); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,stopdd); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   return(0); 
}
int deinit()
{
   return(0); 
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double macd  = iMA(NULL,0,FastEMA,0,MODE_EMA,Price,i)  -iMA(NULL,0,SlowEMA,0,MODE_EMA,Price,i);
      double macdp = iMA(NULL,0,FastEMA,0,MODE_EMA,Price,i+1)-iMA(NULL,0,SlowEMA,0,MODE_EMA,Price,i+1);
         stop[i]   = stop[i+1];
         stopdu[i] = EMPTY_VALUE;
         stopdd[i] = EMPTY_VALUE;
         if (macd*macdp>=0)
         {
            if (macd>0) stop[i] = MathMax(stop[i],Low[i] -iATR(NULL,0,AtrPeriod,i)*AtrMultiplier);
            if (macd<0) stop[i] = MathMin(stop[i],High[i]+iATR(NULL,0,AtrPeriod,i)*AtrMultiplier);
         }
         else
         {
            if (macd>0) { stop[i] = Low[i] -iATR(NULL,0,AtrPeriod,i)*AtrMultiplier; stopdu[i] = stop[i]; }
            if (macd<0) { stop[i] = High[i]+iATR(NULL,0,AtrPeriod,i)*AtrMultiplier; stopdd[i] = stop[i]; }
         }            
   }
   manageAlerts();
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (stopdu[whichBar] != EMPTY_VALUE || stopdd[whichBar] != EMPTY_VALUE)
      {
         if (stopdu[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (stopdd[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" MACD trailing trend changed to "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsNotification) SendNotification(message);
          if (alertsEmail)        SendMail(Symbol()+" MACD trailing",message);
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

